
//////////////////////////////////////////////////////////////////////////////////
// Module Name:    PWM_LED 
// Target Devices: XC6SLX9-2TQG144C
// Tool versions:  ISE WebPACK 14.1
// Description: This example shows how to generate a PWM  signal.
//              The PWM output is displayed on LEDs
//////////////////////////////////////////////////////////////////////////////////

module PWM_LED( clk_50M, reset, led );

input  wire clk_50M;
input  wire reset;
output wire[7:0] led;

reg 	[27:0]  counter;
reg 	[5:0]   PWM_adj;
reg   [6:0]   PWM_width;


always @(posedge clk_50M )
begin
		if( reset == 1)
		begin
			counter <= 0;
		end
		else 
		begin
			counter   <= counter+1;
			PWM_width <= PWM_width[5:0]+ PWM_adj;
			if( counter[27] == 1 )
			begin
				PWM_adj <= counter[26:21];
			end
			else 
			begin
				PWM_adj <= ~ counter[26:21];
			end
	  end
end

	assign led[0] = ~PWM_width[6];
	assign led[1] = ~PWM_width[6];
	assign led[2] = ~PWM_width[6];
	assign led[3] = ~PWM_width[6];
	assign led[4] =  PWM_width[6];
	assign led[5] =  PWM_width[6];
	assign led[6] =  PWM_width[6];
	assign led[7] =  PWM_width[6];

endmodule
